/* This file is part of Eclat.
   Copyright (C) 2012 Sergey Poznyakoff.
 
   Eclat is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.
 
   Eclat is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with Eclat.  If not, see <http://www.gnu.org/licenses/>. */

#include "eclat.h"
static int vpc;
static char *iface;
static char *privaddr;
static int reassoc;
#include "asscaddr-cl.h"

int
eclat_associate_address(CURL *curl, int argc, char **argv)
{
	int i;
	struct ec2_query *q;

	parse_options(argc, argv, &i);
	argc -= i;
	argv += i;

	if (argc != 2)
		die(EX_USAGE, "wrong number of arguments to associate-address");

	q = eclat_query_create(use_ssl ? EC2_QF_HTTPS : 0, endpoint, "/");
	eclat_query_add_param(q, "Action", "AssociateAddress");
	translate_ids(1, argv, "InstanceId");
	eclat_query_add_param(q, "InstanceId", argv[0]);
	if (vpc) {
		eclat_query_add_param(q, "AllocationId", argv[1]);
		if (iface)
			eclat_query_add_param(q, "NetworkInterfaceId", iface);
		if (privaddr)
			eclat_query_add_param(q, "PrivateIpAddress", privaddr);
		if (reassoc)
			eclat_query_add_param(q, "AllowReassociation", "true");
		
	} else {
		eclat_query_add_param(q, "PublicIp", argv[1]);
	}
	return eclat_send_query(curl, q);
}
